package com.nisum.statisticsutils.programs;
import com.nisum.statisticsutils.models.TaxRates;
import com.nisum.statisticsutils.utils.CsvUtils;
import com.nisum.statisticsutils.utils.FileUtils;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;



public class CompareSimsStoreData {
	public static void compareHashMaps(HashMap<String, TaxRates> hm1, HashMap<String, TaxRates> hm3)throws Exception{
		FileUtils fu = new FileUtils("/Users/nisum/Downloads/FileCompare/3217/taxCompare-3217.csv");
		Set<String> k = hm1.keySet();
		System.out.println("UPC\tDB\tDB\tDB\tDB\tSTORE\tSTORE\tSTORE\tSTORE");
		fu.writeLineToFile("UPC\tDB\tDB\tDB\tDB\tSTORE\tSTORE\tSTORE\tSTORE");
		fu.writeLineToFile("UPC\tTax A\tTax B\tTax C\tTax D\tTax A\tTax B\tTax C\tTax D");

		for(String s:k){
			if(hm1.get(s)!=null && hm3.get(s)!=null) {
				System.out.println(s + "\t" +
						hm1.get(s).getTaxA() + "\t" + hm1.get(s).getTaxB() + "\t" + hm1.get(s).getTaxC() + "\t" + hm1.get(s).getTaxD() + "\t" +
						hm3.get(s).getTaxA() + "\t" + hm3.get(s).getTaxB() + "\t" + hm3.get(s).getTaxC() + "\t" + hm3.get(s).getTaxD()
				);


				fu.writeLineToFile(s + "\t" +
						hm1.get(s).getTaxA() + "\t" + hm1.get(s).getTaxB() + "\t" + hm1.get(s).getTaxC() + "\t" + hm1.get(s).getTaxD() + "\t" +
						hm3.get(s).getTaxA() + "\t" + hm3.get(s).getTaxB() + "\t" + hm3.get(s).getTaxC() + "\t" + hm3.get(s).getTaxD()
				);
			}
		}
		fu.closeFileWriter();

	}


	public static void main(String[] args) throws Exception {
		CsvUtils csvSims = new CsvUtils("/Users/nisum/Downloads/FileCompare/3217/sims-3217.csv");
		ArrayList<String> lines = csvSims.readAllLines(true);
		ArrayList<TaxRates> ltrDbSims = new ArrayList<TaxRates>();
		HashMap<String,TaxRates> hmSims = new HashMap<String, TaxRates>();
		for(String s: lines){



			String fsa =  csvSims.getColumnValue(s,",",11);
			if(fsa.toLowerCase().contains("flex spending account") || fsa.toLowerCase().contains("sales restrict")||fsa.toLowerCase().contains("wic") || fsa.toLowerCase().contains("milk bottle deposit")){
				continue;
			}
			String upc =  csvSims.getColumnValue(s,",",1);
			String taxA = csvSims.getColumnValue(s,",",12) + "";
			String taxB = csvSims.getColumnValue(s,",",13) + "";
			String taxC = csvSims.getColumnValue(s,",",14) + "";
			String taxD = csvSims.getColumnValue(s,",",15) + "";

			/*System.out.println("UPC  :" + upc);
			System.out.println("Tax A:" + taxA);
			System.out.println("Tax B:" + taxB);
			System.out.println("Tax C:" + taxC);
			System.out.println("Tax D:" + taxD);*/
			TaxRates tr = new TaxRates(taxA,taxB,taxC,taxD,"");
			hmSims.put(String.format("%013d",(new BigDecimal(upc).toBigInteger())),tr);
		}
		csvSims.closeBufferedReader();


		CsvUtils csvStore = new CsvUtils("/Users/nisum/Downloads/FileCompare/3217/store-3217.csv");
		lines = csvStore.readAllLines(false);
		HashMap<String,TaxRates> hmStore = new HashMap<String,TaxRates>();
		for(String s: lines){

			String upc = csvStore.getColumnValue(s,"\\|",0);
			String taxA= csvStore.getColumnValue(s,"\\|",13) + "";
			String taxB= csvStore.getColumnValue(s,"\\|",14) + "";
			String taxC= csvStore.getColumnValue(s,"\\|",15) + "";
			String taxD= csvStore.getColumnValue(s,"\\|",16) + "";
			/*System.out.println("UPC  :" + upc);
			System.out.println("Tax A:" + taxA);
			System.out.println("Tax B:" + taxB);
			System.out.println("Tax C:" + taxC);
			System.out.println("Tax D:" + taxD);*/
			TaxRates tr = new TaxRates(taxA,taxB,taxC,taxD,"");
			hmStore.put(String.format("%013d",(new BigDecimal(upc).toBigInteger())),tr);
		}
		csvStore.closeBufferedReader();

		CompareSimsStoreData.compareHashMaps(hmSims,hmStore);
	}



}
