package com.nisum.statisticsutils.utils;

import org.apache.commons.mail.EmailAttachment;
import org.apache.commons.mail.EmailException;
import org.apache.commons.mail.MultiPartEmail;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import java.io.IOException;
import java.util.Date;
import java.util.Properties;

public class EmailUtils {

    public static void sendMail(String smtpAddress, int smtpPort, String sendFrom, String sendTo, String subject, String textBody,String attachmentPath) throws EmailException {

        // Create the attachment
        EmailAttachment attachment = new EmailAttachment();
        attachment.setPath(attachmentPath);
        attachment.setDisposition(EmailAttachment.ATTACHMENT);
        attachment.setDescription("All Store Error And UPC Report");
        attachment.setName("AllStoreReport.xlsx");

        // Create the email message
        MultiPartEmail email = new MultiPartEmail();
        email.setHostName(smtpAddress);
        //email.setAuthentication(userName,"Blabla@1234");
        email.setSmtpPort(smtpPort);
        email.addTo(sendTo);
        email.setFrom(sendTo);
        email.setSubject(subject);
        email.setMsg(textBody);

        // add the attachment
        email.attach(attachment);

        // send the email
        email.send();

    }

    public static void sendHtmlMail(String smtpAddress, int smtpPort, String sendFrom, String sendTo, String subject, String textBody, String attachmentPath) throws EmailException, MessagingException, IOException {
        // sets SMTP server properties
        Properties properties = new Properties();
        properties.put("mail.smtp.host", smtpAddress);
        properties.put("mail.smtp.port", smtpPort);
        //properties.put("mail.smtp.auth", "false");
        //properties.put("mail.smtp.starttls.enable", "true");
        //properties.put("mail.user", userName);
        //properties.put("mail.password", password);

        // creates a new session with an authenticator
        /*Authenticator auth = new Authenticator() {
            public PasswordAuthentication getPasswordAuthentication() {
                return new PasswordAuthentication(userName, password);
            }
        };*/
        Session session = Session.getInstance(properties);

        // creates a new e-mail message
        Message msg = new MimeMessage(session);

        msg.setFrom(new InternetAddress(sendFrom));
        InternetAddress[] toAddresses = { new InternetAddress(sendTo) };
        msg.setRecipients(Message.RecipientType.TO, toAddresses);
        msg.setSubject(subject);
        msg.setSentDate(new Date());

        // creates message part
        MimeBodyPart messageBodyPart = new MimeBodyPart();
        messageBodyPart.setContent(textBody, "text/html");

        // creates multi-part
        Multipart multipart = new MimeMultipart();
        multipart.addBodyPart(messageBodyPart);

        MimeBodyPart attachPart = new MimeBodyPart();
        attachPart.attachFile(attachmentPath);

        multipart.addBodyPart(attachPart);

        // sets the multi-part as e-mail's content
        msg.setContent(multipart);

        // sends the e-mail
        Transport.send(msg);


    }


    public static void main(String[] args) throws EmailException {
        EmailUtils.sendMail("smtp.gmail.com",465,"kattanguru@gmail.com","kattanguru@gmail.com","Test Subject","TextBody",System.getProperty("user.dir")+"/TestErrorReport.xlsx");

    }
}
