package com.nisum.statisticsutils.utils;

import com.nisum.statisticsutils.models.ExcelCells;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;

public class ExcelWriteUtils {

	  XSSFWorkbook workbook;
      XSSFSheet sheet,readfiles;


      public ExcelWriteUtils() throws Exception {

    	  workbook = new XSSFWorkbook();
      }

      public void createSheet(String sheetName){
		  sheet = workbook.createSheet(sheetName);
	  }
	  public void setSheet(String sheetName){
      	sheet = workbook.getSheet(sheetName);
	  }

      public void populateCells(ArrayList<ExcelCells> aEC) {
    	for(ExcelCells c: aEC){
    		if(c.getRowNum()==-1){
				Row row = sheet.createRow(getLastRowNum());
				Set<Integer> colKeys = c.getHmColumnValues().keySet();
				for(Integer i:colKeys){
					row.createCell(i).setCellValue(c.getHmColumnValues().get(i));
				}
			}
		}
      }
      
      
      
      public void saveWorkBook(String FilePath) throws FileNotFoundException, IOException {
    	  FileOutputStream fop = new FileOutputStream(new File(FilePath));
    	  workbook.write(fop);
    	  fop.close();
      }
      
      public void closeWorkBookWithoutSaving() throws IOException{
    	  workbook.close();
      }
      
      public void closeWorkBook() throws IOException {

    	  workbook.close();
      }
      
      public Integer getLastRowNum() {
    	  return (sheet.getPhysicalNumberOfRows());    	  
      }
      
      public Integer getLastColNum() {
    	  
    	  int i = 0;
    	  for (Row row : sheet) {	  
    		  while(row.getCell(i)!=null) {
    			  i++;
    		  }
    		  break;
    	  }
    	  return i;
      }
      
     public Row getRowByNumber(Integer rownum) {
    	 return sheet.getRow(rownum);
     }
     
     public Cell getCellByRowColNumber(Row row, Integer colNum) {
    	 return row.getCell(colNum);
     }

     public static void main(String[] args) throws Exception {
		ExcelWriteUtils eu = new ExcelWriteUtils();
		eu.createSheet("abc");
		eu.createSheet("def");
		eu.setSheet("abc");
		 HashMap<Integer, String> hmCells = new HashMap<Integer,String>();
		 hmCells.put(0, "cell0");
		 hmCells.put(1, "cell1");
		ExcelCells ec = new ExcelCells(-1,hmCells);
		ArrayList<ExcelCells> aec = new ArrayList<ExcelCells>();
		aec.add(ec);
		 eu.populateCells(aec);
		eu.setSheet("def");
		 ec = new ExcelCells(-1,hmCells);
		 eu.populateCells(aec);
		eu.saveWorkBook("/Users/nisum/Downloads/test.xlsx");
	 }
}
