package com.nisum.statisticsutils.utils;

import com.jayway.jsonpath.DocumentContext;
import com.jayway.jsonpath.JsonPath;
import gherkin.deps.com.google.gson.JsonArray;
import gherkin.deps.com.google.gson.JsonElement;
import gherkin.deps.com.google.gson.JsonObject;
import gherkin.deps.com.google.gson.JsonParser;
import gherkin.deps.com.google.gson.JsonSyntaxException;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class JsonUtils {

	public String jsonFileToString(String jsonFilePath) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(jsonFilePath)); 
		String str = ""; 
		String st;
		while (true) {
			st = br.readLine();
			if(st==null) {
				break;
			}else {
				str = str + st;
			}
		} 
		br.close();
		return str;
	}
	
	public JsonArray jsonFileToJsonArray(String json) {
		JsonParser jsonParser = new JsonParser();
		return jsonParser.parse(json).getAsJsonArray();
	}
	
	public JsonObject jsonFileToJsonObject(String jsonFilePath) throws JsonSyntaxException, IOException {
		JsonParser jp = new JsonParser();
		return jp.parse(jsonFileToString(jsonFilePath)).getAsJsonObject();
	}
	
	public String modifyJsonWithJsonPathFromFile(String jsonFilePath,String jsonPath,String newValue ) throws JsonSyntaxException, IOException {
		DocumentContext parsedDataContext =  JsonPath.parse(jsonFileToString(jsonFilePath));  
        parsedDataContext.set(jsonPath, newValue);
        return (parsedDataContext.jsonString());
	}
	
	public String modifyJsonWithJsonPathFromJsonString(String jsonString,String jsonPath,String newValue ) throws JsonSyntaxException, IOException {
		DocumentContext parsedDataContext =  JsonPath.parse(jsonString);  
        parsedDataContext.set(jsonPath, newValue);
        return (parsedDataContext.jsonString());
	}
	
	public String searchJsonFileByJsonPath(String jsonFilePath,String jsonPath) throws JsonSyntaxException, IOException {
		DocumentContext parsedDataContext =  JsonPath.parse(jsonFileToString(jsonFilePath));  
        parsedDataContext.read(jsonPath);
        return (parsedDataContext.read(jsonPath).toString());
	}
	
	public String searchJsonStringByJsonPath(String jsonString ,String jsonPath) throws JsonSyntaxException, IOException {
		DocumentContext parsedDataContext =  JsonPath.parse(jsonString);  
        parsedDataContext.read(jsonPath);
        return (parsedDataContext.read(jsonPath).toString());
	}
	
	public JsonArray jsonStringtoJsonArray(String jsonFullString ,String jsonPathOfArrayNode) throws JsonSyntaxException, IOException {
		jsonFullString = searchJsonStringByJsonPath(jsonFullString, jsonPathOfArrayNode);
		JsonParser parser = new JsonParser();
		JsonElement elements = parser.parse(jsonFullString);
		JsonArray jsonArray = elements.getAsJsonArray();
		return jsonArray;
	}

	
	
	
	public static void main(String[] args) throws IOException {
		
	}
}
