package com.nisum.statisticsutils.utils;

import com.mongodb.MongoClient;
import com.mongodb.MongoClientURI;
import com.mongodb.client.FindIterable;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;
import com.mongodb.client.model.Filters;
import com.mongodb.client.model.Sorts;
import org.bson.Document;
import org.bson.conversions.Bson;

public class MongoUtils {	   
	
	MongoClient mongoClient=null;
	MongoDatabase database = null;
	MongoCollection<Document> mc = null;
	public MongoUtils() {
		MongoClientURI mcuri = new MongoClientURI("mongodb://mongodb-octx-taxation-prod:WA3F1ZSKyq8vqLwNf06fNVmBR2UBYCMrQP5kn6VwJ6z2c6xNkcnMb0aaFoz4tRWEFoy4o35yljBzl3xir1LDEA==@mongodb-octx-taxation-prod.mongo.cosmos.azure.com:10255/?ssl=true&replicaSet=globaldb&retrywrites=false&maxIdleTimeMS=120000&appName=@mongodb-octx-taxation-prod@");
	    this.mongoClient = new MongoClient(mcuri);    
	    this.database = mongoClient.getDatabase("octx-taxation");
	    this.mc = database.getCollection("octx-log");
	}
	
	public FindIterable<Document> getAllMatchingDocuments(Bson filter) throws InterruptedException {
		FindIterable<Document> ml = null;
		try{
			if(filter==null) {
				ml = this.mc.find();
			}else {
				ml = this.mc.find(filter);
			}
		}catch(Exception e){
			Thread.sleep(5000);
			if(filter==null) {
				ml = this.mc.find();
			}else {
				ml = this.mc.find(filter);
			}
		}

		
		return ml;
	}
	
	public FindIterable<Document> getAllMatchingDocumentsSorted(Bson filter, Boolean isAscending, String SortBy) throws InterruptedException {
		FindIterable<Document> ml=null;
		try{
			if(isAscending) {
				ml = this.mc.find(filter).sort(Sorts.ascending(SortBy));
			}else {
				ml = this.mc.find(filter).sort(Sorts.descending(SortBy));
			}
		}catch(Exception e) {
			Thread.sleep(5000);
			if(isAscending) {
				ml = this.mc.find(filter).sort(Sorts.ascending(SortBy));
			}else {
				ml = this.mc.find(filter).sort(Sorts.descending(SortBy));
			}
		}
		return ml;
	}
	
	public Document getMatchingDocument(Bson filter) throws InterruptedException {
		try{
			return this.mc.find(filter).first();
		}catch(Exception e){
			Thread.sleep(5000);
			return this.mc.find(filter).first();
		}

	}
	
	public Long getCountOfMatchingRecords(Bson filter) throws InterruptedException {
		try{
			return mc.countDocuments(filter);
		}catch(Exception e){
			Thread.sleep(5000);
			return mc.countDocuments(filter);
		}

		
	}
	
	
	public void closeConnection() {
		mongoClient.close();
	}
	
	
	   public static void main( String args[] ) throws Exception {  
	          MongoClientURI uri = new MongoClientURI("mongodb://mongodb-octx-taxation-prod:WA3F1ZSKyq8vqLwNf06fNVmBR2UBYCMrQP5kn6VwJ6z2c6xNkcnMb0aaFoz4tRWEFoy4o35yljBzl3xir1LDEA==@mongodb-octx-taxation-prod.mongo.cosmos.azure.com:10255/?ssl=true&replicaSet=globaldb&retrywrites=false&maxIdleTimeMS=120000&appName=@mongodb-octx-taxation-prod@");
		      MongoClient mongoClient = new MongoClient(uri);    
		      MongoDatabase database = mongoClient.getDatabase("octx-taxation"); 
		      MongoCollection<Document> mc = database.getCollection("octx-log");
		      
//		      Document myDoc = mc.find().first();
//		      System.out.println(myDoc.toJson());
//		      
//		      FindIterable<Document> ml = mc.find(Filters.eq("percentage",0.0));
//		      for(Document d:ml) {
//		    	  System.out.println(d.toString());
//		      }
//		   
		      
		      MongoUtils mo = new MongoUtils();
		      
		      FindIterable<Document> ml = mo.getAllMatchingDocuments(Filters.and(Filters.eq("orderId","12715178"),Filters.eq("percentage",0.0)));
		      for(Document d:ml) {
		    	  System.out.println(d.toString());
		      }
		      
//		      
//		      for(Document d:ml) {
//		    	  System.out.println(d.toString());
//		    	  Document myDoc = (Document) mo.getAllMatchingDocuments(Filters.and(Filters.eq("orderId", d.toString()),Filters.eq("percentage",0.0))).first();
//		    	  
//			      System.out.println(myDoc.toJson());
//		      }
	      }
	   }  

	

